#include "esphome.h"

using namespace esphome;

class TableHeightSensor : public PollingComponent,  public UARTDevice, public sensor::Sensor{
 public:
  TableHeightSensor(UARTComponent *parent) : PollingComponent(1000), UARTDevice(parent) {}

  byte last[3];
  float value = 0;
  float lastPublished = -1;

  void setup() override {
    // This will be called by App.setup())
  }

  void loop() override {
    while (available()) {
      byte in = read();
      if(last[2] == 0xAA && last[1] == 0xA6){
        value = (((255*in) + last[0]) / 43.225) - 2; // substracting to make it display same number as controller
      }
     last[2] = last[1];
     last[1] = last[0];
     last[0] = in;
     yield();
   }
  }

  void update() override {
    if(value != lastPublished) {
      publish_state(value);
      lastPublished = value;
    }
  }
};
